/*******************************************************************************
 * FoxDialogBoxInputString generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxDialogBoxInputString extends FoxDialogBoxBase within FoxUI
    native(UI)
    config(UI);

enum EInputStringVerifyTags
{
    ISVT_Valid,
    ISVT_Empty,
    ISVT_InvalidChars,
    ISVT_InvalidWords,
    ISVT_MultipleAlphabets,
    ISVT_TooShort,
    ISVT_TooLong,
    ISVT_MAX
};

struct native InputStringDialogBoxProperties
{
    var int MinStringSize;
    var int MaxStringSize;
    var string LocalizedDialogBoxTitle;
    var string LocalizedDialogBoxBody;
    var string DefaultInputString;
    var string LocValid;
    var string LocInvalidChars;
    var string LocInvalidWords;
    var string LocMultipleAlphabets;
    var string LocTooShort;
    var string LocTooLong;
    var bool bEnableStringValidation;
    var bool bEnforceCharacterRestrictions;
    var bool bSpacesAreInvalid;
    var bool bEnforceAlphabetRestrictions;
    var bool bEnforceWordRestrictions;
    var array<string> AdditionalValidChars;
    var delegate<StringInputDelegate> OnStringInput;
    var delegate<DialogButtonPressedDelegate> OnButtonPressed;
    var delegate<InputFieldButtonPressedDelegate> OnInputFieldPressed;

    structdefaultproperties
    {
        MinStringSize=3
        MaxStringSize=16
        LocalizedDialogBoxTitle=""
        LocalizedDialogBoxBody=""
        DefaultInputString=""
        LocValid=""
        LocInvalidChars=""
        LocInvalidWords=""
        LocMultipleAlphabets=""
        LocTooShort=""
        LocTooLong=""
        bEnableStringValidation=true
        bEnforceCharacterRestrictions=true
        bSpacesAreInvalid=true
        bEnforceAlphabetRestrictions=true
        bEnforceWordRestrictions=true
        AdditionalValidChars=none
        S=None
        But=None
        InputFi=None
    }
};

var protected string InputValue;
var private InputBoxVerify InputBox;
var private InputBoxVerifyTag InputStringVerifyTags[EInputStringVerifyTags];
var private const string InputStringDialogLinkage;
var private InputStringDialogBoxProperties CurrentProperties;
var delegate<InputFieldButtonPressedDelegate> __InputFieldButtonPressedDelegate__Delegate;

delegate InputFieldButtonPressedDelegate()
{
    //return;    
}

function ShowDialog(const InputStringDialogBoxProperties Properties)
{
    CurrentProperties = Properties;
    ToggleAllowEscape(true);
    BindDialogButtonPressedDelegate(CurrentProperties.OnButtonPressed);
    BindDialog(Outer.GetVariableObject("_root"), InputStringDialogLinkage);
    SetHeaderText(CurrentProperties.LocalizedDialogBoxTitle);
    SetBodyText(CurrentProperties.LocalizedDialogBoxBody);
    ui_setConfirmButton(LocAcceptLabel, "img://Menu.t_continueIcon", "ei_acceptButtonPressed", "", false, true);
    ui_setCancelButton(LocCancelLabel, "img://Menu.t_cancelIcon", "ei_cancelButtonPressed", "", false, true);
    GenerateStringVerifyTags(Properties);
    InputBox.BoundObjectPath = AddInputBox(0, "", CurrentProperties.MaxStringSize, "ei_resetInput", true,, CurrentProperties.DefaultInputString);
    InputBox.ValidVerifyTagColor = DefaultValidVerifyTagColor;
    InputBox.InvalidVerifyTagColor = DefaultInvalidVerifyTagColor;
    __StringInputDelegate__Delegate = CurrentProperties.OnStringInput;
    __InputFieldButtonPressedDelegate__Delegate = CurrentProperties.OnInputFieldPressed;
    //return;    
}

function ei_acceptButtonPressed(string Arg, optional string Arg2)
{
    local ASValue InvokeRetVal0;
    local GFxObject TextInputBox;

    TextInputBox = Outer.GetVariableObject(InputBox.BoundObjectPath);
    InvokeRetVal0 = TextInputBox.InvokeNoParams("queryInput");
    InputValue = InvokeRetVal0.S;
    // End:0xE6
    if(CurrentProperties.bEnableStringValidation)
    {
        // End:0xE6
        if(!IsStringValid(InputValue))
        {
            as_RefocusInputBox();
            return;
        }
    }
    // End:0x111
    if(__StringInputDelegate__Delegate != none)
    {
        StringInputDelegate(InputValue);
    }
    NotifyButtonPressed(0);
    CloseDialog();
    //return;    
}

function ei_cancelButtonPressed(string Arg)
{
    NotifyButtonPressed(1);
    CloseDialog();
    //return;    
}

protected function ei_resetInput(string unusedValue)
{
    ei_clearErrorMessages(unusedValue);
    // End:0x35
    if(__InputFieldButtonPressedDelegate__Delegate != none)
    {
        InputFieldButtonPressedDelegate();
    }
    //return;    
}

protected function ei_clearErrorMessages(string unusedValue)
{
    ShowVerifyLabel(InputBox, InputStringVerifyTags[1]);
    //return;    
}

event DialogBoxInputStringAcceptButtonPressed()
{
    ei_acceptButtonPressed("");
    //return;    
}

event DialogBoxInputStringCancelButtonPressed()
{
    ei_cancelButtonPressed("");
    //return;    
}

protected function bool IsStringValid(string NewInputValue)
{
    local string NewInputValueWithoutSpaces;

    // End:0x71
    if((CurrentProperties.MinStringSize > 0) && Len(NewInputValue) < CurrentProperties.MinStringSize)
    {
        ShowVerifyLabel(InputBox, InputStringVerifyTags[5]);
        return false;
    }
    // End:0xE2
    if((CurrentProperties.MaxStringSize > 0) && Len(NewInputValue) > CurrentProperties.MaxStringSize)
    {
        ShowVerifyLabel(InputBox, InputStringVerifyTags[6]);
        return false;
    }
    // End:0x127
    if(!CurrentProperties.bSpacesAreInvalid)
    {
        CurrentProperties.AdditionalValidChars.AddItem(" ");
    }
    // End:0x1B3
    if(CurrentProperties.bEnforceCharacterRestrictions && !Outer.EnforceCharacterRestrictionsWithAdditionalCharacters(NewInputValue, CurrentProperties.AdditionalValidChars))
    {
        ShowVerifyLabel(InputBox, InputStringVerifyTags[2]);
        return false;
    }
    // End:0x223
    if(CurrentProperties.bEnforceAlphabetRestrictions && !Outer.EnforceAlphabetRestrictions(NewInputValue))
    {
        ShowVerifyLabel(InputBox, InputStringVerifyTags[4]);
        return false;
    }
    // End:0x293
    if(CurrentProperties.bEnforceWordRestrictions && !Outer.EnforceWordRestrictions(NewInputValue))
    {
        ShowVerifyLabel(InputBox, InputStringVerifyTags[3]);
        return false;
    }
    // End:0x340
    if(!CurrentProperties.bSpacesAreInvalid && CurrentProperties.bEnforceWordRestrictions)
    {
        NewInputValueWithoutSpaces = Repl(NewInputValue, " ", "");
        // End:0x340
        if(!Outer.EnforceWordRestrictions(NewInputValueWithoutSpaces))
        {
            ShowVerifyLabel(InputBox, InputStringVerifyTags[3]);
            return false;
        }
    }
    ShowVerifyLabel(InputBox, InputStringVerifyTags[0]);
    return true;
    //return ReturnValue;    
}

private final function GenerateStringVerifyTags(InputStringDialogBoxProperties Properties)
{
    InputStringVerifyTags[0].TagLabel = Properties.LocValid;
    InputStringVerifyTags[0].bIsValid = true;
    InputStringVerifyTags[1].TagLabel = "";
    InputStringVerifyTags[2].TagLabel = Properties.LocInvalidChars;
    InputStringVerifyTags[3].TagLabel = Properties.LocInvalidWords;
    InputStringVerifyTags[4].TagLabel = Properties.LocMultipleAlphabets;
    InputStringVerifyTags[5].TagLabel = Properties.LocTooShort;
    InputStringVerifyTags[6].TagLabel = Properties.LocTooLong;
    //return;    
}

event SetInputBoxString(string NewInputValue)
{
    local GFxObject TextInputBox;

    TextInputBox = Outer.GetVariableObject(InputBox.BoundObjectPath);
    TextInputBox.SetString("text", NewInputValue);
    //return;    
}

function as_RefocusInputBox()
{
    local GFxObject BoundObject;

    BoundObject = GetBoundObject();
    // End:0x50
    if(BoundObject != none)
    {
        BoundObject.ActionScriptVoid("RefocusInput");
    }
    //return;    
}

defaultproperties
{
    InputStringDialogLinkage="w_emailDialogBox"
    CurrentProperties=(MinStringSize=3,MaxStringSize=16,LocalizedDialogBoxTitle="",LocalizedDialogBoxBody="",DefaultInputString="",LocValid="",LocInvalidChars="",LocInvalidWords="",LocMultipleAlphabets="",LocTooShort="",LocTooLong="",bEnableStringValidation=true,bEnforceCharacterRestrictions=true,bSpacesAreInvalid=true,bEnforceAlphabetRestrictions=true,bEnforceWordRestrictions=true,AdditionalValidChars=none,OnStringInput=S=None,OnButtonPressed=But=None,OnInputFieldPressed=InputFi=None)
}